#!
#! This is a tmake template for building Unix kdevelop project files for applications or libraries.
#!
#${
    if (Config("qt_dll")) {Project('CONFIG += qt');}
    if ( !Project("INTERFACE_DECL_PATH") ) {
	Project('INTERFACE_DECL_PATH = .' );
    }
    if ( Config("qt") ) {
	if ( !(Project("DEFINES") =~ /QT_NODLL/) &&
	     ((Project("DEFINES") =~ /QT_(?:MAKE)?DLL/) || Config("qt_dll") ||
	      ($ENV{"QT_DLL"} && !$ENV{"QT_NODLL"})) ) {
	    Project('TMAKE_QT_DLL = 1');
	    if ( (Project("TARGET") eq "qt") && Project("TMAKE_LIB_FLAG") ) {
		Project('CONFIG += dll');
	    }
	}
    }
    if ( Config("dll") || Project("TMAKE_APP_FLAG") ) {
	Project('CONFIG -= staticlib');
	Project('TMAKE_APP_OR_DLL = 1');
      if ( Config("dll") ) 
         {
         Project('DEV_CPP_TYPE = 3');
         Project('DEFINES += DBUILDING_DLL=1');
         }
      else {
      if ( Config("console") ) {Project('DEV_CPP_TYPE = 1');}
      else {Project('DEV_CPP_TYPE = 0');} }
    } else {
	Project('CONFIG += staticlib');
	Project('DEV_CPP_TYPE = 2');
    }
    if ( Config("warn_off") ) {
	Project('TMAKE_CFLAGS += $$TMAKE_CFLAGS_WARN_OFF');
	Project('TMAKE_CXXFLAGS += $$TMAKE_CXXFLAGS_WARN_OFF');
    } elsif ( Config("warn_on") ) {
	Project('TMAKE_CFLAGS += $$TMAKE_CFLAGS_WARN_ON');
	Project('TMAKE_CXXFLAGS += $$TMAKE_CXXFLAGS_WARN_ON');
    }
    if ( Config("debug") ) {
        if ( Config("thread") ) {
	    if ( Config("dll") ) {
	        Project('TMAKE_CFLAGS += $$TMAKE_CFLAGS_MT_DLLDBG');
	        Project('TMAKE_CXXFLAGS += $$TMAKE_CXXFLAGS_MT_DLLDBG');
 	    } else {
		Project('TMAKE_CFLAGS += $$TMAKE_CFLAGS_MT_DBG');
		Project('TMAKE_CXXFLAGS += $$TMAKE_CXXFLAGS_MT_DBG');
	    }
        }
        Project('TMAKE_CFLAGS += $$TMAKE_CFLAGS_DEBUG');
        Project('TMAKE_CXXFLAGS += $$TMAKE_CXXFLAGS_DEBUG');
        Project('TMAKE_LFLAGS += $$TMAKE_LFLAGS_DEBUG');
        Project('DEFINES += _DEBUG');
        Project('OBJECTS_DIR += debug');
    } elsif ( Config("release") ) {
	if ( Config("thread") ) {
	    if ( Config("dll") ) {
		Project('TMAKE_CFLAGS += $$TMAKE_CFLAGS_MT_DLL');
		Project('TMAKE_CXXFLAGS += $$TMAKE_CXXFLAGS_MT_DLL');
	    } else {
		Project('TMAKE_CFLAGS += $$TMAKE_CFLAGS_MT');
		Project('TMAKE_CXXFLAGS += $$TMAKE_CXXFLAGS_MT');
	    }
	}
	Project('TMAKE_CFLAGS += $$TMAKE_CFLAGS_RELEASE');
	Project('TMAKE_CXXFLAGS += $$TMAKE_CXXFLAGS_RELEASE');
      Project('OBJECTS_DIR += release');
    }

    Project('TMAKE_LIBS += $$LIBS');

    if ( Project("TMAKE_INCDIR") ) {
	AddIncludePath(Project("TMAKE_INCDIR"));
    }
    if ( Config("qt") || Config("opengl") ) {
	Project('CONFIG += windows' );
    }
    if ( Config("qt") ) {
	Project('CONFIG *= moc');
	AddIncludePath(Project("TMAKE_INCDIR_QT"));
	if ( !Config("debug") ) {
	    Project('DEFINES += NO_DEBUG');
	}
	if ( (Project("TARGET") eq "qt") && Project("TMAKE_LIB_FLAG") ) {
	    if ( Project("TMAKE_QT_DLL") ) {
		Project('DEFINES *= QT_MAKEDLL');
		Project('TMAKE_LFLAGS += $$TMAKE_LFLAGS_QT_DLL');
	    }
	} else {
	    Project('TMAKE_LIBS *= $$TMAKE_LIBS_QT');
	    if ( Project("TMAKE_QT_DLL") ) {
		my $qtver =FindHighestLibVersion($ENV{"QTDIR"} . "/lib", "qt");
		Project("TMAKE_LIBS /= s/qt.lib/qt${qtver}.lib/");
		if ( !Config("dll") ) {
		    Project('TMAKE_LIBS *= $$TMAKE_LIBS_QT_DLL');
		}
	    }
	}
    }
    if ( Config("opengl") ) {
	Project('TMAKE_LIBS *= $$TMAKE_LIBS_OPENGL');
    }
    if ( Config("dll") ) {
	Project('TMAKE_LFLAGS_CONSOLE_ANY = $$TMAKE_LFLAGS_CONSOLE_DLL');
	Project('TMAKE_LFLAGS_WINDOWS_ANY = $$TMAKE_LFLAGS_WINDOWS_DLL');
	if ( Project("TMAKE_LIB_FLAG") ) {
	    my $ver = Project("VERSION");
	    $ver =~ s/\.//g;
	    $project{"TARGET_EXT"} = "${ver}.dll";
	} else {
	    $project{"TARGET_EXT"} = ".dll";
	}
    } else {
	Project('TMAKE_LFLAGS_CONSOLE_ANY = $$TMAKE_LFLAGS_CONSOLE');
	Project('TMAKE_LFLAGS_WINDOWS_ANY = $$TMAKE_LFLAGS_WINDOWS');
	if ( Project("TMAKE_APP_FLAG") ) {
	    $project{"TARGET_EXT"} = ".exe";
	} else {
	    $project{"TARGET_EXT"} = ".lib";
	}
    }
    if ( Config("windows") ) {
	if ( Config("console") ) {
	    Project('TMAKE_LFLAGS *= $$TMAKE_LFLAGS_CONSOLE_ANY');
	    Project('TMAKE_LIBS   *= $$TMAKE_LIBS_CONSOLE');
	} else {
	    Project('TMAKE_LFLAGS *= $$TMAKE_LFLAGS_WINDOWS_ANY');
	}
	Project('TMAKE_LIBS   *= $$TMAKE_LIBS_WINDOWS');
    } else {
	Project('TMAKE_LFLAGS *= $$TMAKE_LFLAGS_CONSOLE_ANY');
	Project('TMAKE_LIBS   *= $$TMAKE_LIBS_CONSOLE');
    }
    if ( Config("moc") ) {
	$moc_aware = 1;
    }
    if ( Config("no_cpp") ) 
      {Project('TMAKE_USING_CPP = 0');}
    else
      {Project('TMAKE_USING_CPP = 1');}
    Project('TMAKE_FILETAGS = HEADERS SOURCES DEF_FILE RC_FILE TARGET TMAKE_LIBS DESTDIR DLLDESTDIR $$FILETAGS');
    if ( Project("DEF_FILE") ) {
	Project('TMAKE_LFLAGS *= /DEF:$$DEF_FILE');
    }
    if ( Project("RC_FILE") ) {
	if ( Project("RES_FILE") ) {
	    tmake_error("Both .rc and .res file specified.\n" .
			"Please specify one of them, not both.");
	}
	$project{"RES_FILE"} = $project{"RC_FILE"};
	$project{"RES_FILE"} =~ s/\.rc$/.res/i;
	Project('TARGETDEPS += $$RES_FILE');
    }
    if ( Project("RES_FILE") ) {
	Project('TMAKE_LIBS *= $$RES_FILE');
    }
    StdInit();
    if ( Project("VERSION") ) {
	$project{"VER_MAJ"} = $project{"VERSION"};
	$project{"VER_MAJ"} =~ s/\.\d+$//;
	$project{"VER_MIN"} = $project{"VERSION"};
	$project{"VER_MIN"} =~ s/^\d+\.//;
    }
    Project('dll:TMAKE_CLEAN += $$DESTDIR$$TARGET.lib');
    $project{"ALL_FILES"} = $project{"TARGET"} . ".kdevprj " . $project{"HEADERS"} . " " . $project{"SOURCES"};
    foreach ( split (/\s/, $project{"HEADERS"}) )
       {
       $project{"ALL_FILES_LIST"} .= "[" . $_ . "]\n";
       $project{"ALL_FILES_LIST"} .= "dist=true\n";
       $project{"ALL_FILES_LIST"} .= "isntall=false\n";
       $project{"ALL_FILES_LIST"} .= "install_location=\n";
       $project{"ALL_FILES_LIST"} .= "type=HEADER\n";
       $project{"ALL_FILES_LIST"} .= "\n";
       }
    foreach ( split (/\s/, $project{"SOURCES"}) )
       {
       $project{"ALL_FILES_LIST"} .= "[" . $_ . "]\n";
       $project{"ALL_FILES_LIST"} .= "dist=true\n";
       $project{"ALL_FILES_LIST"} .= "install=false\n";
       $project{"ALL_FILES_LIST"} .= "install_location=\n";
       $project{"ALL_FILES_LIST"} .= "type=SOURCE\n";
       $project{"ALL_FILES_LIST"} .= "\n";
       }
#$}
[Config for BinMakefileAm]
addcxxflags=
bin_program=#$ ExpandGlue("TARGET",$project{"DESTDIR"},"",$project{"TARGET_EXT"});
cflags=
cppflags=
cxxflags=\s-O0 -g3 -Wall
ldadd=
ldflags=\s\s

[General]
AMChanged=false
author=
configure_args=
email=
kdevprj_version=1.3
lfv_open_groups=
make_options=-j1
makefiles=Makefile
project_name=#$ Expand("TARGET");
project_type=normal_cpp
sub_dir=
version=0.1
version_control=None
workspace=1

[LFV Groups]
Headers=*.h,*.hh,*.hxx,*.hpp,*.H
Others=*
Sources=*.cpp,*.c,*.cc,*.C,*.cxx,*.ec,*.ecpp,*.lxx,*.l++,*.ll,*.l
groups=Headers,Sources,Others

[Makefile]
files=#$ ExpandGlue("ALL_FILES","",",","");
sub_dirs=
type=prog_main

[#$ ExpandGlue("TARGET","","",".kdevprj]");
dist=true
install=false
install_location=
type=DATA

#$ Expand("ALL_FILES_LIST");
