/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            DefaultGeometry3DCreator.h                      //
////////////////////////////////////////////////////////////////////////////////

#ifndef DEFAULTGEOMETRY3DCREATOR_H
#define DEFAULTGEOMETRY3DCREATOR_H

#include "Geometry3DCreator.h"

namespace X3DTK {
namespace X3D {

/// Concrete component Creator for the geometry3D component defining the default 
/// X3D nodes.

class DefaultGeometry3DCreator : public Geometry3DCreator
{
public:
  /// Constructor.
  DefaultGeometry3DCreator();
  /// Destructor.
  virtual ~DefaultGeometry3DCreator();
  
  /// Creates a Box.
  SFNode createBox() const;
  /// Creates a Cone.
  SFNode createCone() const;
  /// Creates a Cylinder.
  SFNode createCylinder() const;
  /// Creates an IndexedFaceSet.
  SFNode createIndexedFaceSet() const;
  /// Creates a Sphere.
  SFNode createSphere() const;
};

}
}

#endif
