/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            DefaultRenderingCreator.h                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef DEFAULTRENDERINGCREATOR_H
#define DEFAULTRENDERINGCREATOR_H

#include "RenderingCreator.h"

namespace X3DTK {
namespace X3D {

/// Concrete component Creator for the Rendering component defining the default 
/// X3D nodes.

class DefaultRenderingCreator : public RenderingCreator
{
public:
  /// Constructor.
  DefaultRenderingCreator();
  /// Destructor.
  virtual ~DefaultRenderingCreator();

  /// Creates a Color.
  SFNode createColor() const;
  /// Creates a ColorRGBA.
  SFNode createColorRGBA() const;
  /// Creates a Coordinate.
  SFNode createCoordinate() const;
  /// Creates a IndexedLineSet.
  SFNode createIndexedLineSet() const;
  /// Creates a Normal.
  SFNode createNormal() const;
  /// Creates a PointSet.
  SFNode createPointSet() const;
  /// Creates a TriangleFanSet.
  SFNode createTriangleFanSet() const;
  /// Creates a TriangleSet.
  SFNode createTriangleSet() const;
  /// Creates a TriangleStripSet.
  SFNode createTriangleStripSet() const;
};

}
}

#endif
