#include "DefaultLightingCreator.h"
#include <DirectionalLight.h>
#include <PointLight.h>
#include <SpotLight.h>

namespace X3DTK {
namespace X3D {

DefaultLightingCreator::DefaultLightingCreator()
{
  defineNewCreationFunction<DefaultLightingCreator>("DirectionalLight", &DefaultLightingCreator::createDirectionalLight);
  defineNewCreationFunction<DefaultLightingCreator>("PointLight",       &DefaultLightingCreator::createPointLight);
  defineNewCreationFunction<DefaultLightingCreator>("SpotLight",        &DefaultLightingCreator::createSpotLight);
}

DefaultLightingCreator::~DefaultLightingCreator()
{
}

SFNode DefaultLightingCreator::createDirectionalLight() const
{
  return new DirectionalLight();
}

SFNode DefaultLightingCreator::createPointLight() const
{
  return new PointLight();
}

SFNode DefaultLightingCreator::createSpotLight() const
{
  return new SpotLight();
}

}
}
