/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            X3DNodeProxy.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DNODEPROXY_H
#define X3DNODEPROXY_H

#include "X3DTypes.h"

namespace X3DTK {

class Type;

/// Abstract base class defining an X3DNodeProxy.

class X3DNodeProxy
{
public:  
  /// Constructor.
  X3DNodeProxy();
  /// Destructor.
  virtual ~X3DNodeProxy() = 0;
  // Deletes the components when the proxy is deleted.
  void setAutoDeleteComponents(bool value);
  /// Empties the list of component and delete them if deleteComponents is TRUE
  /// and autoDelete is TRUE.
  virtual void reset() = 0;
  
protected:  
  /// Adds a type.
  virtual void addType(const Type *type) = 0;
    
  /// If autoDelete is set to TRUE, when the proxy is removed, the components are 
  /// removed too.
  bool autoDelete;
  
  friend class Type; 
};

}

#endif
