/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            TextureCoordinate.h                             //
////////////////////////////////////////////////////////////////////////////////

#ifndef TEXTURECOORDINATE_H
#define TEXTURECOORDINATE_H

#include "X3DTextureCoordinateNode.h"

namespace X3DTK {
namespace X3D {

/// Class of the <a href="../../doc/X3DSpecs/Part01/components/texturing.html">
/// Texturing component</a> defining a TextureCoordinate.
/// (<a href="../../doc/X3DSpecs/Part01/components/texturing.html#TextureCoordinate">
/// documentation</a>).

class TextureCoordinate : public X3DTextureCoordinateNode
{
public:  
  /// Constructor.
  TextureCoordinate();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~TextureCoordinate();

protected:
  /// Copy constructor.	
  TextureCoordinate(const TextureCoordinate &N);
};

}
}

#endif
