#include "X3DTextureCoordinateNode.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

X3DTextureCoordinateNode::X3DTextureCoordinateNode()
: X3DGeometricPropertyNode()
{
  defineTypeName("X3DTextureCoordinateNode", "Texturing");
}

X3DTextureCoordinateNode::X3DTextureCoordinateNode(const MFVec2f &point)
: X3DGeometricPropertyNode(), _point(point)
{
  defineTypeName("X3DTextureCoordinateNode", "Texturing");
}

X3DTextureCoordinateNode::X3DTextureCoordinateNode(const X3DTextureCoordinateNode &N)
: X3DGeometricPropertyNode(N), _point(N._point)
{
}

SFNode X3DTextureCoordinateNode::clone() const
{
  return 0;
}

X3DTextureCoordinateNode::~X3DTextureCoordinateNode()
{
}

void X3DTextureCoordinateNode::setPoint(const MFVec2f &point)
{
  _point = point;
}

void X3DTextureCoordinateNode::load(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("point");
  if (index != -1)
    _point = MFVec2f(element->getAttribute(index));
}

SFString X3DTextureCoordinateNode::write() const
{
  SFString attr;
  if (!_point.empty())
    attr += " point=\"" + toSFString(_point) + "\"";
  
  return attr;
}

}
}
