/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            BboxUpdaterGeometry3DVisitor.h                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef BBOXUPDATERGEOMETRY3DVISITOR_H
#define BBOXUPDATERGEOMETRY3DVISITOR_H

#include "Geometry3DVisitor.h"
#include "BboxUpdaterGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class Box;
class Cone;
class Cylinder;
class Sphere;

/// Visitor for the Geometry3D component of the BboxUpdater module.

class BboxUpdaterGeometry3DVisitor : public Geometry3DVisitor
{
public:
  /// Constructor.
  BboxUpdaterGeometry3DVisitor();
  /// Destructor.
  virtual ~BboxUpdaterGeometry3DVisitor();

  /// Enters a Box.
  virtual void enterBox(Box *B) const;
  /// Enters a Cone.
  virtual void enterCone(Cone *C) const;
  /// Enters a Cylinder.
  virtual void enterCylinder(Cylinder *C) const;
  /// Enters a Sphere.
  virtual void enterSphere(Sphere *S) const;



protected:
  BboxUpdaterGlobalVariables *globalVariables;
};

}
}

#endif
