#include "MeshDFSCoreWalker.h"
#include "NodeWalkingProxy.h"
#include "NodeVisitingProxy.h"
#include "X3DMeshGroupingNode.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace Mesh {

DFSCoreWalker::DFSCoreWalker()
: CoreWalker()
{
  defineNewWalkingFunction<DFSCoreWalker, X3DGroupingNode>(&DFSCoreWalker::walkX3DGroupingNode);
}

DFSCoreWalker::~DFSCoreWalker()
{
}

void DFSCoreWalker::walkX3DGroupingNode(X3DGroupingNode *N) const
{
  nodeVisitingProxy->enter(N);
  
  MFNode children = N->getChildren();
  for (MFNode::iterator it = children.begin(); it != children.end(); ++it)
    if ((*it != 0) && (nodeVisitingProxy->walkOn(N, *it)))
      nodeWalkingProxy->walk(*it);
  
  nodeVisitingProxy->leave(N);
}

}
}
