#include "MeshTransform.h"

namespace X3DTK {
namespace Mesh {

Transform::Transform()
: X3DGroupingNode()
{
  defineTypeName("Transform");
}

Transform::Transform(const Transform &T)
: X3DGroupingNode(T), _transform(T._transform)
{
}

SFNode Transform::clone() const
{
  return new Transform(*this);
}

Transform::~Transform()
{
}

void Transform::setTransform(const SFMatrix34f &M)
{
  _transform = M;
}

const SFMatrix34f &Transform::getTransform() const
{
  return _transform;
}

}
}
