#include "X3DMeshGroupingNode.h"

#include <iostream>
#include <algorithm>

using namespace std;

namespace X3DTK {
namespace Mesh {

X3DGroupingNode::X3DGroupingNode()
: X3DNode()
{
  defineTypeName("X3DGroupingNode");
}

X3DGroupingNode::X3DGroupingNode(const X3DGroupingNode &N)
: X3DNode(N), _children(N._children)
{
}

SFNode X3DGroupingNode::clone() const
{
  return 0;
}

X3DGroupingNode::~X3DGroupingNode()
{
}

bool X3DGroupingNode::addChild(const SFAbstractNode &N)
{
  if (dynamic_cast<X3DNode *>(N) != 0)
  {
    _children.push_back(static_cast<SFNode>(N));
    return true;
  }
  
  cerr << "X3DGroupingNode::addChild : a node of type " << N->getTypeName() << " cannot be a child!" << endl;
  return false;    
}

bool X3DGroupingNode::setChild(const SFAbstractNode &N)
{
  if (dynamic_cast<X3DNode *>(N) != 0)
  {
    _children.push_back(static_cast<SFNode>(N));
    return true;
  }
  
  cerr << "X3DGroupingNode::setChild : a node of type " << N->getTypeName() << " cannot be a child!" << endl;
  return false;    
}

bool X3DGroupingNode::removeChild(const SFAbstractNode &N)
{
  MFNode::iterator res = find(_children.begin(), _children.end(), N);
  if (res != _children.end())
  {
    _children.erase(res);
    return true;
  }  
    
  return false;
}

}
}
